package org.ow2.orchestra.env.descriptor;

import org.ow2.orchestra.env.Descriptor;
import org.ow2.orchestra.env.Environment;
import org.ow2.orchestra.env.WireContext;
import org.ow2.orchestra.env.WireException;

public class ContextRefDescriptor extends AbstractDescriptor implements
    Descriptor {

  private static final long serialVersionUID = 1L;

  private String contextName;

  public Object construct(final WireContext wireContext) {
    if (this.contextName == null) {
      return wireContext;
    }
    final Environment environment = Environment.getCurrent();
    if (environment == null) {
      throw new WireException("can't get context '" + this.contextName
          + "': no current environment");
    }
    return environment.getContext(this.contextName);
  }

  public String getContextName() {
    return this.contextName;
  }

  public void setContextName(final String contextName) {
    this.contextName = contextName;
  }
}
