/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.jmx.commands;

import org.ow2.orchestra.deployment.Deployer;
import org.ow2.orchestra.env.Environment;
import org.ow2.orchestra.facade.Deployment;
import org.ow2.orchestra.facade.def.ProcessDefinition;
import org.ow2.orchestra.facade.def.impl.ProcessDefinitionImpl;
import org.ow2.orchestra.services.commands.Command;

public final class DeployCommand implements Command<ProcessDefinition> {

  /**
   *
   */
  private static final long serialVersionUID = 1L;
  /**
   *
   */
  private final Deployment bpelDeployment;

  /**
   * @param bpelDeployment
   */
  public DeployCommand(final Deployment bpelDeployment) {
    this.bpelDeployment = bpelDeployment;
  }
  public ProcessDefinition execute(final Environment environment) {
    final Deployer deployer = new Deployer();

    final ProcessDefinition bpelProcess = new ProcessDefinitionImpl(deployer.deploy(this.bpelDeployment, environment));
    return bpelProcess;
  }
}
