package org.ow2.orchestra.osgi;

import java.net.URL;
import java.net.URLClassLoader;

import org.osgi.framework.Bundle;

/**
 * @author Guillaume Porcher
 *
 */
public final class EnvironmentResourcesLoader extends URLClassLoader {

  private final Bundle envBundle;
  /**
   * @param urls
   * @param parent
   */
  public EnvironmentResourcesLoader(final URL envUrl, final Bundle envBundle, final ClassLoader parent) {
    super(new URL[] {envUrl}, parent);
    this.envBundle = envBundle;
  }
  @Override
  public URL getResource(final String name) {
    final URL url = this.findResource(name);
    if (url != null) {
      return url;
    }
    final URL url2 = this.envBundle.getResource(name);
    if (url2 != null) {
      return url2;
    }
    return super.getResource(name);
  }

  @Override
  protected Class< ? > findClass(final String name) throws ClassNotFoundException {
    throw new ClassNotFoundException(name);
  }

}
